% sdetect.m
%
% This program detects startles in GSR data
%
% Programmed By: Jennifer Healey
% Last Modified: Dec 12,1999
% Further Modified By:
% Date:
%
% Input:
%
% This startle detector takes two vectors as input:
%
% fvector -the function vector of a sampled signal 
% tvector -it's associated time vector
%
% Output:
%  
% It returns four vectors : 
% 
% bt - a vector containing the times of the beginnings of each of the startle
% bv - the associated value 
% mt - a vector containing the times for the maximum of each of the startles 
% mv - it's the associated value

%function [bt, bv, mt, mv]=sdetect(values_gsr,Fs)

Fs=31;
s=testgsr;

%s=values_gsr;  	%s for signal

lgsr=length(s);
lgsr2=lgsr/2;

t=(1:lgsr)/Fs;

%clear all answer vectors
bt=[];
bv=[];
mt=[];
mv=[];

hold off
[b,a]=ellip(4,0.1,40,.2*2/Fs);
[H,w]=freqz(b,a,lgsr);
sf=filter(b,a,s);
vker1=filter([1 -1],1,sf);
vker2=filter([1 0 -1],1,sf);
vker3=filter([-1 8 0 -8 1],1,sf);

save vker1 vker1
save vker2 vker2
save vker3 vker3


figure(1)
plot(t,sf)
hold on
plot(t,vker1*8,'g')
plot(t,(vker2*8)+2,'r')
plot(t,vker3+5,'c')
hold off









